/[gentoo-x86]/dev-vcs/git/git-1.7.8.6.ebuild
Gentoo

Contents of /dev-vcs/git/git-1.7.8.6.ebuild

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.12 - (show annotations) (download)
Sun Aug 19 16:58:25 2012 UTC (23 months ago) by armin76
Branch: MAIN
Changes since 1.11: +2 -2 lines
alpha/s390/sh/sparc stable wrt #418381

(Portage version: 2.1.11.5/cvs/Linux ia64)

1 # Copyright 1999-2012 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/git-1.7.8.6.ebuild,v 1.11 2012/07/27 17:14:39 grobian Exp $
4
5 EAPI=4
6
7 GENTOO_DEPEND_ON_PERL=no
8
9 # bug #329479: git-remote-testgit is not multiple-version aware
10 PYTHON_DEPEND="python? 2"
11 [[ ${PV} == *9999 ]] && SCM="git-2"
12 EGIT_REPO_URI="git://git.kernel.org/pub/scm/git/git.git"
13
14 inherit toolchain-funcs eutils elisp-common perl-module bash-completion-r1 python ${SCM}
15
16 MY_PV="${PV/_rc/.rc}"
17 MY_P="${PN}-${MY_PV}"
18
19 DOC_VER=${MY_PV}
20
21 DESCRIPTION="GIT - the stupid content tracker, the revision control system heavily used by the Linux kernel team"
22 HOMEPAGE="http://www.git-scm.com/"
23 if [[ ${PV} != *9999 ]]; then
24 SRC_URI_SUFFIX="gz"
25 SRC_URI_GOOG="http://git-core.googlecode.com/files"
26 SRC_URI_KORG="mirror://kernel/software/scm/git"
27 SRC_URI="${SRC_URI_GOOG}/${MY_P}.tar.${SRC_URI_SUFFIX}
28 ${SRC_URI_KORG}/${MY_P}.tar.${SRC_URI_SUFFIX}
29 ${SRC_URI_GOOG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
30 ${SRC_URI_KORG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
31 doc? (
32 ${SRC_URI_KORG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
33 ${SRC_URI_GOOG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
34 )"
35 KEYWORDS="alpha amd64 arm hppa ia64 ~mips ppc ppc64 s390 sh sparc x86 ~ppc-aix ~amd64-fbsd ~sparc-fbsd ~x86-fbsd ~x64-freebsd ~x86-freebsd ~ia64-hpux ~x86-interix ~amd64-linux ~ia64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
36 else
37 SRC_URI=""
38 KEYWORDS=""
39 fi
40
41 LICENSE="GPL-2"
42 SLOT="0"
43 IUSE="+blksha1 +curl cgi doc emacs gtk +iconv +perl +python ppcsha1 tk +threads +webdav xinetd cvs subversion"
44
45 # Common to both DEPEND and RDEPEND
46 CDEPEND="
47 !blksha1? ( dev-libs/openssl )
48 sys-libs/zlib
49 perl? ( dev-lang/perl[-build] dev-libs/libpcre )
50 tk? ( dev-lang/tk )
51 curl? (
52 net-misc/curl
53 webdav? ( dev-libs/expat )
54 )
55 emacs? ( virtual/emacs )"
56
57 RDEPEND="${CDEPEND}
58 perl? ( dev-perl/Error
59 dev-perl/Net-SMTP-SSL
60 dev-perl/Authen-SASL
61 cgi? ( virtual/perl-CGI )
62 cvs? ( >=dev-vcs/cvsps-2.1 dev-perl/DBI dev-perl/DBD-SQLite )
63 subversion? ( dev-vcs/subversion[-dso,perl] dev-perl/libwww-perl dev-perl/TermReadKey )
64 )
65 python? ( gtk?
66 (
67 >=dev-python/pygtk-2.8
68 dev-python/pygtksourceview:2
69 ) )"
70
71 # This is how info docs are created with Git:
72 # .txt/asciidoc --(asciidoc)---------> .xml/docbook
73 # .xml/docbook --(docbook2texi.pl)--> .texi
74 # .texi --(makeinfo)---------> .info
75 DEPEND="${CDEPEND}
76 app-arch/cpio
77 doc? (
78 app-text/asciidoc
79 app-text/docbook2X
80 sys-apps/texinfo
81 )"
82
83 # Live ebuild builds man pages and HTML docs, additionally
84 if [[ ${PV} == *9999 ]]; then
85 DEPEND="${DEPEND}
86 app-text/asciidoc
87 app-text/xmlto"
88 fi
89
90 SITEFILE=50${PN}-gentoo.el
91 S="${WORKDIR}/${MY_P}"
92
93 REQUIRED_USE="
94 cgi? ( perl )
95 cvs? ( perl )
96 subversion? ( perl )
97 webdav? ( curl )
98 "
99
100 pkg_setup() {
101 if use subversion && has_version dev-vcs/subversion && built_with_use --missing false dev-vcs/subversion dso ; then
102 ewarn "Per Gentoo bugs #223747, #238586, when subversion is built"
103 ewarn "with USE=dso, there may be weird crashes in git-svn. You"
104 ewarn "have been warned."
105 fi
106 if use python ; then
107 python_set_active_version 2
108 python_pkg_setup
109 fi
110 }
111
112 # This is needed because for some obscure reasons future calls to make don't
113 # pick up these exports if we export them in src_unpack()
114 exportmakeopts() {
115 local myopts
116
117 if use blksha1 ; then
118 myopts="${myopts} BLK_SHA1=YesPlease"
119 elif use ppcsha1 ; then
120 myopts="${myopts} PPC_SHA1=YesPlease"
121 fi
122
123 if use curl ; then
124 use webdav || myopts="${myopts} NO_EXPAT=YesPlease"
125 else
126 myopts="${myopts} NO_CURL=YesPlease"
127 fi
128
129 # broken assumptions, because of broken build system ...
130 myopts="${myopts} NO_FINK=YesPlease NO_DARWIN_PORTS=YesPlease"
131 myopts="${myopts} INSTALL=install TAR=tar"
132 myopts="${myopts} SHELL_PATH=${EPREFIX}/bin/sh"
133 myopts="${myopts} SANE_TOOL_PATH="
134 myopts="${myopts} OLD_ICONV="
135 myopts="${myopts} NO_EXTERNAL_GREP="
136
137 # can't define this to null, since the entire makefile depends on it
138 sed -i -e '/\/usr\/local/s/BASIC_/#BASIC_/' Makefile
139
140 use iconv \
141 || myopts="${myopts} NO_ICONV=YesPlease"
142 use tk \
143 || myopts="${myopts} NO_TCLTK=YesPlease"
144 use perl \
145 && myopts="${myopts} INSTALLDIRS=vendor USE_LIBPCRE=yes" \
146 || myopts="${myopts} NO_PERL=YesPlease"
147 use python \
148 || myopts="${myopts} NO_PYTHON=YesPlease"
149 use subversion \
150 || myopts="${myopts} NO_SVN_TESTS=YesPlease"
151 use threads \
152 && myopts="${myopts} THREADED_DELTA_SEARCH=YesPlease"
153 use cvs \
154 || myopts="${myopts} NO_CVS=YesPlease"
155 # Disabled until ~m68k-mint can be keyworded again
156 # if [[ ${CHOST} == *-mint* ]] ; then
157 # myopts="${myopts} NO_MMAP=YesPlease"
158 # myopts="${myopts} NO_IPV6=YesPlease"
159 # myopts="${myopts} NO_STRLCPY=YesPlease"
160 # myopts="${myopts} NO_MEMMEM=YesPlease"
161 # myopts="${myopts} NO_MKDTEMP=YesPlease"
162 # myopts="${myopts} NO_MKSTEMPS=YesPlease"
163 # fi
164 if [[ ${CHOST} == ia64-*-hpux* ]]; then
165 myopts="${myopts} NO_NSEC=YesPlease"
166 fi
167 if [[ ${CHOST} == *-solaris* ]]; then
168 myopts="${myopts} NEEDS_LIBICONV=YesPlease"
169 fi
170 if [[ ${CHOST} == *-*-aix* ]]; then
171 myopts="${myopts} NO_FNMATCH_CASEFOLD=YesPlease"
172 fi
173
174 has_version '>=app-text/asciidoc-8.0' \
175 && myopts="${myopts} ASCIIDOC8=YesPlease"
176 myopts="${myopts} ASCIIDOC_NO_ROFF=YesPlease"
177
178 # Bug 290465:
179 # builtin-fetch-pack.c:816: error: 'struct stat' has no member named 'st_mtim'
180 [[ "${CHOST}" == *-uclibc* ]] && \
181 myopts="${myopts} NO_NSEC=YesPlease"
182
183 export MY_MAKEOPTS="${myopts}"
184 }
185
186 src_unpack() {
187 if [[ ${PV} != *9999 ]]; then
188 unpack ${MY_P}.tar.${SRC_URI_SUFFIX}
189 cd "${S}"
190 unpack ${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
191 use doc && \
192 cd "${S}"/Documentation && \
193 unpack ${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
194 cd "${S}"
195 else
196 git-2_src_unpack
197 cd "${S}"
198 #cp "${FILESDIR}"/GIT-VERSION-GEN .
199 fi
200
201 }
202
203 src_prepare() {
204 # Noperl is being merged to upstream as of 2009/04/05
205 #epatch "${FILESDIR}"/20090305-git-1.6.2-noperl.patch
206
207 # GetOpt-Long v2.38 is strict
208 # Merged in 1.6.3 final 2009/05/07
209 #epatch "${FILESDIR}"/20090505-git-1.6.2.5-getopt-fixes.patch
210
211 # JS install fixup
212 # Merged in 1.7.5.x
213 #epatch "${FILESDIR}"/git-1.7.2-always-install-js.patch
214
215 # Fix false positives with t3404 due to SHELL=/bin/false for the portage
216 # user.
217 # Merged upstream
218 #epatch "${FILESDIR}"/git-1.7.3.4-avoid-shell-issues.patch
219
220 # bug #350075: t9001: fix missing prereq on some tests
221 # Merged upstream
222 #epatch "${FILESDIR}"/git-1.7.3.4-fix-perl-test-prereq.patch
223
224 # bug #350330 - automagic CVS when we don't want it is bad.
225 epatch "${FILESDIR}"/git-1.7.3.5-optional-cvs.patch
226
227 sed -i \
228 -e 's:^\(CFLAGS =\).*$:\1 $(OPTCFLAGS) -Wall:' \
229 -e 's:^\(LDFLAGS =\).*$:\1 $(OPTLDFLAGS):' \
230 -e 's:^\(CC = \).*$:\1$(OPTCC):' \
231 -e 's:^\(AR = \).*$:\1$(OPTAR):' \
232 -e "s:\(PYTHON_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
233 -e "s:\(PERL_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
234 Makefile || die "sed failed"
235
236 # Never install the private copy of Error.pm (bug #296310)
237 sed -i \
238 -e '/private-Error.pm/s,^,#,' \
239 perl/Makefile.PL
240
241 # Fix docbook2texi command
242 sed -i 's/DOCBOOK2X_TEXI=docbook2x-texi/DOCBOOK2X_TEXI=docbook2texi.pl/' \
243 Documentation/Makefile || die "sed failed"
244 }
245
246 git_emake() {
247 # bug #326625: PERL_PATH, PERL_MM_OPT
248 # bug #320647: PYTHON_PATH
249 PYTHON_PATH=""
250 use python && PYTHON_PATH="$(PYTHON -a)"
251 emake ${MY_MAKEOPTS} \
252 DESTDIR="${D}" \
253 OPTCFLAGS="${CFLAGS}" \
254 OPTLDFLAGS="${LDFLAGS}" \
255 OPTCC="$(tc-getCC)" \
256 OPTAR="$(tc-getAR)" \
257 prefix="${EPREFIX}"/usr \
258 htmldir="${EPREFIX}"/usr/share/doc/${PF}/html \
259 sysconfdir="${EPREFIX}"/etc \
260 PYTHON_PATH="${PYTHON_PATH}" \
261 PERL_PATH="${EPREFIX}/usr/bin/perl" \
262 PERL_MM_OPT="" \
263 GIT_TEST_OPTS="--no-color" \
264 "$@"
265 # This is the fix for bug #326625, but it also causes breakage, see bug
266 # #352693.
267 # PERL_PATH="${EPREFIX}/usr/bin/env perl" \
268 }
269
270 src_configure() {
271 exportmakeopts
272 }
273
274 src_compile() {
275 git_emake || die "emake failed"
276
277 if use emacs ; then
278 elisp-compile contrib/emacs/git{,-blame}.el \
279 || die "emacs modules failed"
280 fi
281
282 if use perl && use cgi ; then
283 git_emake \
284 gitweb/gitweb.cgi \
285 || die "emake gitweb/gitweb.cgi failed"
286 fi
287
288 cd "${S}"/Documentation
289 if [[ ${PV} == *9999 ]] ; then
290 git_emake man \
291 || die "emake man failed"
292 if use doc ; then
293 git_emake info html \
294 || die "emake info html failed"
295 fi
296 else
297 if use doc ; then
298 git_emake info \
299 || die "emake info html failed"
300 fi
301 fi
302 }
303
304 src_install() {
305 git_emake \
306 install || \
307 die "make install failed"
308
309 # Depending on the tarball and manual rebuild of the documentation, the
310 # manpages may exist in either OR both of these directories.
311 find man?/*.[157] >/dev/null 2>&1 && doman man?/*.[157]
312 find Documentation/*.[157] >/dev/null 2>&1 && doman Documentation/*.[157]
313
314 dodoc README Documentation/{SubmittingPatches,CodingGuidelines}
315 use doc && dodir /usr/share/doc/${PF}/html
316 for d in / /howto/ /technical/ ; do
317 docinto ${d}
318 dodoc Documentation${d}*.txt
319 use doc && dohtml -p ${d} Documentation${d}*.html
320 done
321 docinto /
322 # Upstream does not ship this pre-built :-(
323 use doc && doinfo Documentation/{git,gitman}.info
324
325 newbashcomp contrib/completion/git-completion.bash ${PN}
326
327 if use emacs ; then
328 elisp-install ${PN} contrib/emacs/git.{el,elc} || die
329 elisp-install ${PN} contrib/emacs/git-blame.{el,elc} || die
330 #elisp-install ${PN}/compat contrib/emacs/vc-git.{el,elc} || die
331 # don't add automatically to the load-path, so the sitefile
332 # can do a conditional loading
333 touch "${ED}${SITELISP}/${PN}/compat/.nosearch"
334 elisp-site-file-install "${FILESDIR}"/${SITEFILE} || die
335 fi
336
337 if use python && use gtk ; then
338 dobin "${S}"/contrib/gitview/gitview
339 python_convert_shebangs ${PYTHON_ABI} "${ED}"/usr/bin/gitview
340 dodoc "${S}"/contrib/gitview/gitview.txt
341 fi
342
343 dobin contrib/fast-import/git-p4
344 dodoc contrib/fast-import/git-p4.txt
345 newbin contrib/fast-import/import-tars.perl import-tars
346 newbin contrib/git-resurrect.sh git-resurrect
347
348 dodir /usr/share/${PN}/contrib
349 # The following are excluded:
350 # completion - installed above
351 # emacs - installed above
352 # examples - these are stuff that is not used in Git anymore actually
353 # gitview - installed above
354 # p4import - excluded because fast-import has a better one
355 # patches - stuff the Git guys made to go upstream to other places
356 # svnimport - use git-svn
357 # thunderbird-patch-inline - fixes thunderbird
358 for i in \
359 blameview buildsystems ciabot continuous convert-objects fast-import \
360 hg-to-git hooks remotes2config.sh remotes2config.sh rerere-train.sh \
361 stats svn-fe vim workdir \
362 ; do
363 cp -rf \
364 "${S}"/contrib/${i} \
365 "${ED}"/usr/share/${PN}/contrib \
366 || die "Failed contrib ${i}"
367 done
368
369 if use perl && use cgi ; then
370 # We used to install in /usr/share/${PN}/gitweb
371 # but upstream installs in /usr/share/gitweb
372 # so we will install a symlink and use their location for compat with other
373 # distros
374 dosym /usr/share/gitweb /usr/share/${PN}/gitweb
375
376 # INSTALL discusses configuration issues, not just installation
377 docinto /
378 newdoc "${S}"/gitweb/INSTALL INSTALL.gitweb
379 newdoc "${S}"/gitweb/README README.gitweb
380
381 find "${ED}"/usr/lib64/perl5/ \
382 -name .packlist \
383 -exec rm \{\} \;
384 else
385 rm -rf "${ED}"/usr/share/gitweb
386 fi
387
388 if ! use subversion ; then
389 rm -f "${ED}"/usr/libexec/git-core/git-svn \
390 "${ED}"/usr/share/man/man1/git-svn.1*
391 fi
392
393 if use xinetd ; then
394 insinto /etc/xinetd.d
395 newins "${FILESDIR}"/git-daemon.xinetd git-daemon
396 fi
397
398 newinitd "${FILESDIR}"/git-daemon.initd git-daemon
399 newconfd "${FILESDIR}"/git-daemon.confd git-daemon
400
401 fixlocalpod
402 }
403
404 src_test() {
405 local disabled=""
406 local tests_cvs="t9200-git-cvsexportcommit.sh \
407 t9400-git-cvsserver-server.sh \
408 t9401-git-cvsserver-crlf.sh \
409 t9600-cvsimport.sh \
410 t9601-cvsimport-vendor-branch.sh \
411 t9602-cvsimport-branches-tags.sh \
412 t9603-cvsimport-patchsets.sh"
413 local tests_perl="t5502-quickfetch.sh \
414 t5512-ls-remote.sh \
415 t5520-pull.sh"
416 # Bug #225601 - t0004 is not suitable for root perm
417 # Bug #219839 - t1004 is not suitable for root perm
418 # t0001-init.sh - check for init notices EPERM* fails
419 local tests_nonroot="t0001-init.sh \
420 t0004-unwritable.sh \
421 t0070-fundamental.sh \
422 t1004-read-tree-m-u-wf.sh \
423 t3700-add.sh \
424 t7300-clean.sh"
425
426 # Unzip is used only for the testcase code, not by any normal parts of Git.
427 if ! has_version app-arch/unzip ; then
428 einfo "Disabling tar-tree tests"
429 disabled="${disabled} t5000-tar-tree.sh"
430 fi
431
432 cvs=0
433 use cvs && let cvs=$cvs+1
434 if [[ ${EUID} -eq 0 ]]; then
435 if [[ $cvs -eq 1 ]]; then
436 ewarn "Skipping CVS tests because CVS does not work as root!"
437 ewarn "You should retest with FEATURES=userpriv!"
438 disabled="${disabled} ${tests_cvs}"
439 fi
440 einfo "Skipping other tests that require being non-root"
441 disabled="${disabled} ${tests_nonroot}"
442 else
443 [[ $cvs -gt 0 ]] && \
444 has_version dev-vcs/cvs && \
445 let cvs=$cvs+1
446 [[ $cvs -gt 1 ]] && \
447 built_with_use dev-vcs/cvs server && \
448 let cvs=$cvs+1
449 if [[ $cvs -lt 3 ]]; then
450 einfo "Disabling CVS tests (needs dev-vcs/cvs[USE=server])"
451 disabled="${disabled} ${tests_cvs}"
452 fi
453 fi
454
455 if ! use perl ; then
456 einfo "Disabling tests that need Perl"
457 disabled="${disabled} ${tests_perl}"
458 fi
459
460 # Reset all previously disabled tests
461 cd "${S}/t"
462 for i in *.sh.DISABLED ; do
463 [[ -f "${i}" ]] && mv -f "${i}" "${i%.DISABLED}"
464 done
465 einfo "Disabled tests:"
466 for i in ${disabled} ; do
467 [[ -f "${i}" ]] && mv -f "${i}" "${i}.DISABLED" && einfo "Disabled $i"
468 done
469
470 # Avoid the test system removing the results because we want them ourselves
471 sed -e '/^[[:space:]]*$(MAKE) clean/s,^,#,g' \
472 -i "${S}"/t/Makefile
473
474 # Clean old results first
475 cd "${S}/t"
476 git_emake clean
477
478 # Now run the tests
479 cd "${S}"
480 einfo "Start test run"
481 git_emake test
482 rc=$?
483
484 # Display nice results
485 cd "${S}/t"
486 git_emake aggregate-results
487
488 # And exit
489 [ $rc -eq 0 ] || die "tests failed. Please file a bug."
490 }
491
492 showpkgdeps() {
493 local pkg=$1
494 shift
495 elog " $(printf "%-17s:" ${pkg}) ${@}"
496 }
497
498 pkg_postinst() {
499 use emacs && elisp-site-regen
500 use python && python_mod_optimize git_remote_helpers
501 einfo "Please read /usr/share/bash-completion/git for Git bash completion"
502 elog "These additional scripts need some dependencies:"
503 echo
504 showpkgdeps git-quiltimport "dev-util/quilt"
505 showpkgdeps git-instaweb \
506 "|| ( www-servers/lighttpd www-servers/apache )"
507 echo
508 }
509
510 pkg_postrm() {
511 use emacs && elisp-site-regen
512 use python && python_mod_cleanup git_remote_helpers
513 }

  ViewVC Help
Powered by ViewVC 1.1.20